__gnu_pbds::tree< Key, Mapped, Cmp_Fn, Tag, Node_Update, _Alloc >(3cxx)

NAME
__gnu_pbds::tree< Key, Mapped, Cmp_Fn, Tag, Node_Update, _Alloc >

SYNOPSIS

Inherits __gnu_pbds::basic_branch< Key, Mapped, rb_tree_tag, detail::tree_traits< Key, Mapped, std::less< Key >, null_node_update, rb_tree_tag, std::allocator< char > > ::node_update, __gnu_cxx::typelist::create2< std::less< Key >, PB_DS_TREE_NODE_AND_IT_TRAITS >::type, std::allocator< char > >.

  Public Types

typedef Cmp_Fn cmp_fn
Comparison functor type.
typedef detail::tree_traits< Key, Mapped, std::less< Key >, null_node_update, rb_tree_tag, std::allocator< char > > ::node_update node_update

  Public Member Functions

tree (const cmp_fn &c)
Constructor taking some policy objects. r_cmp_fn will be copied by the Cmp_Fn object of the container object.
tree (const tree &other)
template<typename It > tree (It first, It last)
Constructor taking __iterators to a range of value_types. The value_types between first_it and last_it will be inserted into the container object.
template<typename It > tree (It first, It last, const cmp_fn &c)
Constructor taking __iterators to a range of value_types and some policy objects The value_types between first_it and last_it will be inserted into the container object. r_cmp_fn will be copied by the cmp_fn object of the container object.
tree & operator= (const tree &other)
void swap (tree &other)

Detailed Description

  template<typename Key, typename Mapped, typename Cmp_Fn = std::less<Key>, typename Tag = rb_tree_tag, template< typename Node_CItr, typename Node_Itr, typename Cmp_Fn_, typename _Alloc_ > class Node_Update = null_node_update, typename _Alloc = std::allocator<char>>
class __gnu_pbds::tree< Key, Mapped, Cmp_Fn, Tag, Node_Update, _Alloc >" A tree-based container.

Template Parameters
    Key Key type.
    Mapped Map type.
    Cmp_Fn Comparison functor.
    Tag Instantiating data structure type, see container_tag.
    Node_Update Updates tree internal-nodes, restores invariants when invalidated. XXX See design::tree-based-containersnode invariants.
    _Alloc Allocator type.

Base tag choices are: ov_tree_tag, rb_tree_tag, splay_tree_tag.

Base is basic_branch.

Definition at line 635 of file assoc_container.hpp.

Author

Generated automatically by Doxygen for libstdc++ from the source code.